﻿// Copyright (c) .NET Foundation and Contributors. Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

using System.Threading;
using System.Threading.Tasks;
using Microsoft.CodeAnalysis;
using Microsoft.CodeAnalysis.CSharp.Syntax;

namespace Roslynator.CSharp.Refactorings;

internal static class AvoidLockingOnPubliclyAccessibleInstanceRefactoring
{
    public static Task<Document> RefactorAsync(
        Document document,
        LockStatementSyntax lockStatement,
        CancellationToken cancellationToken = default)
    {
        return IntroduceFieldToLockOnRefactoring.RefactorAsync(document, lockStatement, cancellationToken);
    }
}
